varying float attPlayer, v;
varying vec3 vVertex;
varying vec3 vNormal;

uniform mat4 mTransWorld;

varying float groundLevel;
varying vec3 vWorldVertexPos;

void computeLight()
{
	vec3 lightDirPlayer = vec3(gl_LightSource[1].position.xyz - vVertex);
	
	float dPlayer = length(lightDirPlayer);
	
	attPlayer = 1.0 / ( gl_LightSource[1].constantAttenuation + 
	(gl_LightSource[1].linearAttenuation*dPlayer) + 
	(gl_LightSource[1].quadraticAttenuation*dPlayer*dPlayer) );
}

void main ()
{
	float xcoord,ycoord,zcoord;
	vNormal = gl_Normal;
	vVertex = vec3(gl_ModelViewMatrix * gl_Vertex);

	vWorldVertexPos = vec3(mTransWorld * gl_Vertex);	
	groundLevel = vWorldVertexPos.y;
	
	computeLight();
	
	gl_Position = gl_ModelViewProjectionMatrix * gl_Vertex;	
	
	//Texture Coordinates
	xcoord = gl_Vertex.x;
	zcoord = gl_Vertex.z;
	ycoord = gl_Vertex.y;
	
	float coeff = 1.0/8.0;
	
	// projection1. y is largest normal component
	// so use x and z to sample texture
	 gl_TexCoord[0] = vec4(xcoord*coeff,zcoord*coeff,0.0,0.0); //first projection
	// projection2. x is largest normal component
	// so use z and y to sample texture
	 gl_TexCoord[1] = vec4(zcoord*coeff,ycoord*coeff,0.0,0.0); //second projection
	// projection3. z is largest normal component
	// so use x and y to sample texture
	 gl_TexCoord[2] = vec4(xcoord*coeff,ycoord*coeff,0.0,0.0); //third projection
	
	float x = abs(gl_Normal.x);
	float y = abs(gl_Normal.y);
	float z = abs(gl_Normal.z);
	
	v = 0.0;
	if(x > y && x >= z)
	{
		v = 1.0;
	}
	if(z > y && z >= x)
	{
		v = -1.0;
	} 
			
	gl_Position = ftransform();
}
